﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ahp
{
    /// <summary>
    /// Processes hierarchy analysis
    /// </summary>
    public class HierarchyProcessor
    {
        public AnalysisResult Analyse(Hierarchy hierarchy)
        {
            AnalysisResult result = new AnalysisResult();
            foreach (Alternative alternative in hierarchy.Alternatives)
            {
                result.Add(alternative, 0M);
            }

            CriterionNodeCollection lowestCriterionNodes = hierarchy.GoalNode.GetLowestCriterionNodes();
            foreach (CriterionNode lowestCriterionNode in lowestCriterionNodes)
            {
                foreach (Alternative alternative in hierarchy.Alternatives)
                {
                    result[alternative] += hierarchy[alternative, lowestCriterionNode].GlobalPriority;
                }
            }

            return result;
        }
    }
}
